package archiver

import "log"
import "time"
//import "os"
//import "fmt"
//import "net/url"
import "ma/mqtt"
//import "ma/config"
import "ma/counter"
import "ma/database"

var dbh *database.DatabaseHandle


func InitArchiver() {
  log.Printf("Archiver initializing")
  dbh = database.NewDatabaseHandle()
}

func InputArchiver() {
  for {
    select {
    case mqttMessage := <- mqtt.InputChannel:
      message := database.Message { time.Now(), mqttMessage.Topic, string(mqttMessage.Payload) }
      handleMessage(message)
    }
  }
}

func handleMessage(message database.Message) {
  log.Printf("Archiving Timestamp: %s, Topic: %s, Payload: %s", message.Time, message.Topic, message.Payload)
  dbh.StoreMessage(&message)
  counter.S("Stored")
}

